""" Problem 1 - UND ASCII Art Solutions
Scaling   U and N	D Letter  Line Width  Blank Lines     Blank Lines
Factor      Dim           Dim     of Letters  between U & N   between N & D
1          3 × 5         4 × 5       1            1                0
2          5 × 10        6 × 10      2            2                1
3          7 × 15        8 × 15      3            3                2
4          9 × 20       10 × 20      4            4                3
5         11 × 25       12 × 25      5            5                4

"""

def main():
    inFile = open("prob1.dat")
    outFile = open("prob1.out", 'w')

##    inFile = open("prob1test.dat")
##    outFile = open("prob1test.out", 'w')

    scalingFactor = int(inFile.readline().strip())
    lineWidth = scalingFactor    

    U_N_width = scalingFactor * 5
    U_N_D_ht = scalingFactor * 2 + 1

    # Print U
    for count in range(U_N_D_ht - lineWidth):
        print('|'*lineWidth + ' '*(U_N_width - 2*lineWidth) + '|'*lineWidth)
        outFile.write('|'*lineWidth + ' '*(U_N_width - 2*lineWidth) + '|'*lineWidth+'\n')
    for count in range(lineWidth-1):
        print('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth)
        outFile.write('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth+'\n')
    print('\\'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '/'*lineWidth)
    outFile.write('\\'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '/'*lineWidth+'\n')

    # Spaces between U & N
    print('\n'*scalingFactor, end='')
    outFile.write('\n'*scalingFactor)

    # Print N
    for count in range(U_N_D_ht):
        print('|'*lineWidth + ' '*count+ '\\'*lineWidth+ ' '*(U_N_width-3*lineWidth-count) + '|'*lineWidth)
        outFile.write('|'*lineWidth + ' '*count+ '\\'*lineWidth+ ' '*(U_N_width-3*lineWidth-count) + '|'*lineWidth+'\n')

    # Spaces between N & D
    print('\n'*(scalingFactor-1), end='')
    outFile.write('\n'*(scalingFactor-1))
        
    # Print D
    print(' '*lineWidth + '_'*(U_N_width - 2*lineWidth))
    outFile.write(' '*lineWidth + '_'*(U_N_width - 2*lineWidth)+'\n')
    print('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '\\'*lineWidth)
    outFile.write('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '\\'*lineWidth+'\n')
    for count in range(lineWidth-2):
        print('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth)
        outFile.write('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth+'\n')
    for count in range(U_N_D_ht - lineWidth*2 + 1):
        print('|'*lineWidth + ' '*(U_N_width - 2*lineWidth) + '|'*lineWidth)
        outFile.write('|'*lineWidth + ' '*(U_N_width - 2*lineWidth) + '|'*lineWidth+'\n')
    for count in range(lineWidth-1):
        print('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth)
        outFile.write('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '|'*lineWidth+'\n')
    print('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '/'*lineWidth)
    outFile.write('|'*lineWidth + '_'*(U_N_width - 2*lineWidth) + '/'*lineWidth+'\n')

    inFile.close()
    outFile.close()

main()
