""" Problem 2 - Stamp Out Holes Solutions
    Uses a brute force backtracking algorithm that is
    O(2**n).  With at most 25 stamps it finishs in < a
    minute.  (Takes about 15 minutes for 30 stamps)
"""

def main():
    inFile = open("prob2.dat")
    outFile = open("prob2.out", 'w')

##    inFile = open("prob2test.dat")
##    outFile = open("prob2test.out", 'w')
    
    foreverStampValue = int(inFile.readline().strip())
    stampLine = inFile.readline().strip()
    stampList = stampLine.split()
    for index in range(len(stampList)):
        if stampList[index] == 'F' or stampList[index] == 'f':
            stampList[index] = foreverStampValue
        else:
            stampList[index] = int(stampList[index])
    #print(stampList)

    stampSum =0
    for stamp in stampList:
        stampSum += stamp
    
    #print("sum",stampSum)

    sumPossible = [False]*(stampSum+1)

    #print(SumPossible)
    sumPossible[0] = True

    findSum(sumPossible, stampList, 0, 0)

    firstNotPossibleAmt = stampSum + 1
    foundFirstNotPossibleAmt = False
    notPossibleCount = 0
    for sum in range(stampSum):
        if not sumPossible[sum]:
            # print("sum not possible", sum)
            notPossibleCount += 1
            if not foundFirstNotPossibleAmt:
                firstNotPossibleAmt = sum
                foundFirstNotPossibleAmt = True
    #print("The least amount that cannot be made exactly is " + str(firstNotPossibleAmt))
    #print("The number of amounts between 0 and "+str(stampSum)+" that cannot be made exactly is "+str(notPossibleCount))
    outFile.write("The least amount that cannot be made exactly is " + str(firstNotPossibleAmt) + "\n")
    outFile.write("The number of amounts between 0 and "+str(stampSum)+" that cannot be made exactly is "+str(notPossibleCount)+"\n")
    inFile.close()
    outFile.close()
            
def findSum(sumPossible, stampList, sum, level):
    #print(sum, level)
    sumPossible[sum] = True
    if level < len(stampList):
        findSum(sumPossible, stampList, sum, level+1)
        findSum(sumPossible, stampList, sum+stampList[level], level+1)
        


    
main()
