""" Problem 4 - Crazy Eight Divisors Solution """
import math

def main():
    inFile = open("prob4.dat")
    outFile = open("prob4.out", 'w')
##    inFile = open("prob4test.dat")
##    outFile = open("prob4test.out", 'w')
    n = int(inFile.readline().strip())
    count = 0
    for i in range(24, n+1):
        if hasEightDivisors(i):
            #print(i)
            count += 1
    print("The count of numbers not exceeding "+str(n)+" with exactly eight divisors is "+str(count)+".\n")
    outFile.write("The count of numbers not exceeding "+str(n)+" with exactly eight divisors is "+str(count)+".\n")
    
def hasEightDivisors(val):
    sqrtVal = int(math.sqrt(val))
    if sqrtVal*sqrtVal == val:
        divisorCnt = 1
    else:
        divisorCnt = 2
    for divisor in range(2, sqrtVal+1):
        if val % divisor == 0:
            divisorCnt += 2
            if divisorCnt > 8:
                return False
    return divisorCnt == 8

    
main()
