'''
    Problem 6 - Expanding Password Solution
'''
    

def main():
    inFile = open("prob6.dat",'r')
    outFile = open("pro6.out", 'w')
##    inFile = open("prob6test.dat",'r')
##    outFile = open("pro6test.out", 'w')
    
    for line in inFile:
        lineSplit = line.strip().split()
        password = lineSplit[0]
        minLength = int(lineSplit[1])
        #print(password, minLength)
        base = 9
        initialPassword = password
        while len(password) < minLength and base >= 2:
            password = expandPassword(initialPassword, base)
            base -= 1

        if len(password) < minLength:
            password += '@'* (minLength - len(password))
            
        #print("Old password "+initialPassword+" expanded to length "+str(minLength)+" is "+password)
        outFile.write("Old password "+initialPassword+" expanded to length "+str(minLength)+" is "+password+'\n')
        
    inFile.close()
    outFile.close()

def expandPassword(initialPassword, base):
    charList = []
    for char in initialPassword:
        if char.isdigit():
            val = int(char)
            if val < base:
                charList.append(char)
            else:
                expandedCharStack = []
                while val > 0:
                    rem = val % base
                    expandedCharStack.append(str(rem))
                    val = val // base
                while len(expandedCharStack) > 0:
                    charList.append(expandedCharStack.pop())
        else:
            charList.append(char)

    strResult = ""
    for item in charList:
        strResult += item
        
    return strResult
            
            
main()
