'''
    Problem 7 - B/W Photo Copyright Solution
'''
    

def main():
    inFile = open("prob7.dat",'r')
    outFile = open("pro7.out", 'w')
##    inFile = open("prob7test.dat",'r')
##    outFile = open("pro7test.out", 'w')

    # read photo C
    dimList = inFile.readline().strip().split()
    cHt = int(dimList[0])
    cWidth = int(dimList[1])
    c = []
    for row in range(cHt):
        rowList = inFile.readline().strip().split()
        for col in range(cWidth):
            rowList[col] = int(rowList[col])
        c.append(rowList)
##    print(cHt,cWidth)
##    for row in range(cHt):
##        print(c[row])

    # read photo T
    dimList = inFile.readline().strip().split()
    tHt = int(dimList[0])
    tWidth = int(dimList[1])
    t = []
    for row in range(tHt):
        rowList = inFile.readline().strip().split()
        for col in range(tWidth):
            rowList[col] = int(rowList[col])
        t.append(rowList)
##    print(tHt,tWidth)
##    for row in range(tHt):
##        print(t[row])
        
    foundCopy = False
    # Check all possible starting locations of C in T
    for startCol in range(tWidth - cWidth):
        for startRow in range(tHt - cHt):
            col = 0
            mismatch = False
            while not mismatch and col < cWidth:
                row = 0
                while not mismatch and row < cHt:
                    if c[row][col] == t[startRow+row][startCol+col]:
                        row += 1
                    else:
                        mismatch = True
                col += 1
            if not mismatch:
                #print("Photograph C was found in T starting at row "+str(startRow)+" and column "+str(startCol)+"\n")
                outFile.write("Photograph C was found in T starting at row "+str(startRow)+" and column "+str(startCol)+"\n")
                inFile.close()
                outFile.close()
                return


    #print("Photograph C was not found in T")
    outFile.write("Photograph C was not found in T\n")
    
    inFile.close()
    outFile.close()        
            
main()
