'''
    Problem 5 - Valley Sort Solution
'''
    
def main():
    inFile = open("prob5.dat",'r')
    
    aList = []
    numberOfValues = int(inFile.readline().strip())

    for line in inFile:
        aList.append(int(line.strip()))
    print("list length:", len(aList))
    print( "\nInitial list: ",end="")
    print( aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1])

    aList.sort(reverse=True)
    print("Done sorting")
    print( "\nSorted list: ",end="")
    print( aList[0],aList[1],aList[2], '...',aList[-3], aList[-2],aList[-1])

    resultList = [-1]*numberOfValues
    frontIndex = 0
    rearIndex = numberOfValues - 1
    toFront = True
    for item in aList:
        if toFront:
            resultList[frontIndex] = item
            frontIndex += 1
            toFront = False
        else:
            resultList[rearIndex] = item
            rearIndex -= 1
            toFront = True
    print( "\nValley Sorted list: ",end="")
    print( resultList[0],resultList[1],resultList[2], '...',resultList[-3], resultList[-2],resultList[-1])


    outFile = open("pro5.out", 'w')
    outFile.write(str(numberOfValues)+'\n')
    for item in resultList:
        outFile.write(str(item)+'\n')
    outFile.close()
        
            
main()
